class QXEmbed

# class QXEmbed | The QXEmbed widget is a graphical socket that can embed an external X-Window. More...
Definition | `#include <qxembed.h>`
Inherits | QWidget (qt) [public ]
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Types

- enum Protocol { XEMBED, XPLAIN }

#### Public Methods

- QXEmbed ( QWidget *parent=0, const char *name=0, WFlags f = 0 )
- ~QXEmbed ()
- void setProtocol ( Protocol proto )
- Protocol protocol ()
- void embed ( WId w )
- WId embeddedWinId () const
- QSize sizeHint () const
- QSize minimumSizeHint () const
- QSizePolicy sizePolicy () const
- bool eventFilter ( QObject *, QEvent * )
- void setAutoDelete ( bool )
- bool autoDelete () const
- bool customWhatsThis () const
- void enterWhatsThisMode ()

#### Signals

- void embeddedWindowDestroyed ()

#### Public Static Methods

- static void initialize ()
- static void embedClientIntoWindow ( QWidget* client, WId window )
- static bool processClientCmdline ( QWidget* client, int& argc, char ** argv )

#### Protected Methods

- bool event ( QEvent * )
- void keyPressEvent ( QKeyEvent * )
- void keyReleaseEvent ( QKeyEvent * )
- void focusInEvent ( QFocusEvent * )
- void focusOutEvent ( QFocusEvent * )
- void resizeEvent (QResizeEvent *)
- void showEvent ( QShowEvent * )
- bool x11Event ( XEvent* )
- virtual void windowChanged ( WId w )
- bool focusNextPrevChild ( bool next )

## Detailed Description

A QXEmbed widget serves as an embedder that can manage one single embedded X-window. These so-called client windows can be arbitrary QWidgets.

There are two different ways of using QXEmbed, from the embedder's or from the client's side. When using it from the embedder's side, you already know the window identifier of the window that should be embedded. Simply call embed() with this identifier as parameter.

Embedding from the client's side requires that the client knows the window identifier of the respective embedder widget. Use either embedClientIntoWindow() or the high-level wrapper processClientCmdline().

If a window has been embedded succesfully, embeddedWinId() returns its id.

Reimplement the change handler windowChanged() to catch embedding or the destruction of embedded windows. In the latter case, the embedder also emits a signal embeddedWindowDestroyed() for convenience.

QXEmbed ( QWidget *parent=0, const char *name=0, WFlags f = 0 ) | ### QXEmbed

Constructs a xembed widget.

The parent, name and f arguments are passed to the QFrame constructor.

~QXEmbed () | ### ~QXEmbed

Destructor. Cleans up the focus if necessary.

void initialize () | ### initialize

[static]

Embedded applications should call this function to make sure they support the XEMBED protocol. It is called automatically when you use embedClientIntoWindow() or processClientCmdline(). Clients might have to call it manually when you use embed().

enum Protocol { XEMBED, XPLAIN } | ### Protocol

void setProtocol ( Protocol proto ) | ### setProtocol

Sets the protocol used for embedding windows. This function must be called before embedding a window. Protocol XEMBED provides maximal functionality (focus, tabs, etc) but requires explicit cooperation from the embedded window. Protocol XPLAIN provides maximal compatibility with embedded applications that do not support the XEMBED protocol. The default is XEMBED.

Future work: Create a protocol AUTO that selects the best option. This will be possible with the XEMBED v2 specification.

Protocol protocol () | ### protocol

Returns the protocol used for embedding the current window.

Returns: the protocol used by QXEmbed.

void embed ( WId w ) | ### embed

Embeds the window with the identifier w into this xembed widget.

This function is useful if the server knows about the client window that should be embedded. Often it is vice versa: the client knows about its target embedder. In that case, it is not necessary to call embed(). Instead, the client will call the static function embedClientIntoWindow().

Parameters:

w | the identifier of the window to embed
proto | is the embedding protocol to use

See also: embeddedWinId()

WId embeddedWinId () | ### embeddedWinId

[const]

Returns the window identifier of the embedded window, or 0 if no window is embedded yet.

Returns: the id of the embedded window (0 if no window is embedded)

void embedClientIntoWindow ( QWidget* client, WId window ) | ### embedClientIntoWindow

[static]

A function for clients that embed themselves. The widget client will be embedded in the window window. The application has to ensure that window is the handle of the window identifier of an QXEmbed widget.

bool processClientCmdline ( QWidget* client, int& argc, char ** argv ) | ### processClientCmdline

[static]

A utility function for clients that embed theirselves. The widget client will be embedded in the window that is passed as -embed command line argument.

The function returns TRUE on sucess or FALSE if no such command line parameter is specified.

See also: embedClientIntoWindow()

QSize sizeHint () | ### sizeHint

[const]

Returns a size sufficient for the embedded window

QSize minimumSizeHint () | ### minimumSizeHint

[const]

Returns the minimum size specified by the embedded window.

QSizePolicy sizePolicy () | ### sizePolicy

[const]

Specifies that this widget can use additional space, and that it can survive on less than sizeHint().

Reimplemented from QWidget.

bool eventFilter ( QObject *, QEvent * ) | ### eventFilter

void setAutoDelete ( bool ) | ### setAutoDelete

bool autoDelete () | ### autoDelete

[const]

bool customWhatsThis () | ### customWhatsThis

[const]

Reimplemented from QWidget.

void enterWhatsThisMode () | ### enterWhatsThisMode

void embeddedWindowDestroyed () | ### embeddedWindowDestroyed

[signal]

This signal is emitted when the embedded window has been destroyed.

See also: embeddedWinId()

bool event ( QEvent * ) | ### event

[protected]

void keyPressEvent ( QKeyEvent * ) | ### keyPressEvent

[protected]

void keyReleaseEvent ( QKeyEvent * ) | ### keyReleaseEvent

[protected]

Reimplemented from QWidget.

void focusInEvent ( QFocusEvent * ) | ### focusInEvent

[protected]

Reimplemented from QWidget.

void focusOutEvent ( QFocusEvent * ) | ### focusOutEvent

[protected]

Reimplemented from QWidget.

void resizeEvent (QResizeEvent *) | ### resizeEvent

[protected]

void showEvent ( QShowEvent * ) | ### showEvent

[protected]

Reimplemented from QWidget.

bool x11Event ( XEvent* ) | ### x11Event

[protected]

Reimplemented from QWidget.

void windowChanged ( WId w ) | ### windowChanged

[protected virtual]

A change handler that indicates that the embedded window has been changed. The window handle can also be retrieved with embeddedWinId().

Parameters:

w | the handle of the window that changed

bool focusNextPrevChild ( bool next ) | ### focusNextPrevChild

[protected]

Generated by: root on macppc.ports.openbsd.org on Sat Sep 6 10:36:37 2003, using kdoc 2.0a54.